/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.statistik.boundary;

import javax.persistence.NoResultException;
import javax.persistence.NonUniqueResultException;
import javax.persistence.EntityNotFoundException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import de.ivu.elect.business.statistik.entity.StatistikLauf;
import de.ivu.elect.business.statistik.entity.StatistikLaufUK;

public abstract class AbstractStatistikLaufDAO extends de.ivu.elect.jee.entity.AbstractDAO<StatistikLauf,
        de.ivu.elect.business.statistik.entity.StatistikLaufPK
    , StatistikLaufUK> {

  private static final long serialVersionUID = 1L;

  private static final Logger LOG = LoggerFactory.getLogger(AbstractStatistikLaufDAO.class);

  public AbstractStatistikLaufDAO() {
    super();
  }

  public boolean isEntityWithPKPresent(
            de.ivu.elect.business.statistik.entity.StatistikLaufPK
     pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk) != null;
    }

    return false;
  }

  @Override
  public StatistikLauf findByPrimaryKey(
        de.ivu.elect.business.statistik.entity.StatistikLaufPK
      pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk.getId());
    }

    throw new IllegalArgumentException("PK oder PK.getId() ist null! [pk = " + pk + "]");
  }


  @Override
  protected StatistikLauf findByPrimaryKey(Long id) {
    if (id == null) {
      throw new IllegalArgumentException("ID ist null! [id = " + id + "]");
    }
  return getEntityManager().find(StatistikLauf.class, id, CACHE_PROPERTIES);
  }



     /**
      * Name: StatusNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM StatistikLauf o WHERE o.status = ?1 ORDER by o.zeitpunktDesLaufs ASC<br>
      * SQL: <br>
      */
     public java.util.List<StatistikLauf> findByStatus( @javax.annotation.Nonnull de.ivu.elect.business.statistik.entity.StatistikLaufStatus status,  int limit) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.statistik.entity.StatistikLaufStatus statusCheckedAndAttached =  checkAndAttach(status, de.ivu.elect.business.statistik.entity.StatistikLaufStatus.class, "status"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("STATISTIK_LAUF.Status")
                              .setParameter(1, statusCheckedAndAttached)
                                                  .setMaxResults(limit)
                                        .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByStatus - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("StatistikLauf, findByStatus - NonUniqueResultException, Parameter: "
           + ", status:'"+status+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByStatus(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM StatistikLauf o WHERE o.wahl=?1<br>
      * SQL: <br>
      */
     public java.util.List<StatistikLauf> findByWahl( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("STATISTIK_LAUF.Wahl")
                              .setParameter(1, wahlCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("StatistikLauf, findByWahl - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahl(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlterminNichtWahlAusloeserNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM StatistikLauf o WHERE o.wahltermin=?1 AND o.wahl IS NULL AND o.ausloeser=?2<br>
      * SQL: <br>
      */
     public java.util.List<StatistikLauf> findByWahlterminNichtWahlAusloeser( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahltermin wahltermin,  @javax.annotation.Nonnull String ausloeser) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahltermin wahlterminCheckedAndAttached =  checkAndAttach(wahltermin, de.ivu.elect.business.wahl.entity.Wahltermin.class, "wahltermin"); ;
		  			  String ausloeserCheckedAndAttached =  checkAndAttach(ausloeser, String.class, "ausloeser"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("STATISTIK_LAUF.WahlterminNichtWahlAusloeser")
                              .setParameter(1, wahlterminCheckedAndAttached)
                                        .setParameter(2, ausloeserCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahlterminNichtWahlAusloeser - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("StatistikLauf, findByWahlterminNichtWahlAusloeser - NonUniqueResultException, Parameter: "
           + ", wahltermin:'"+wahltermin+"'"
           + ", ausloeser:'"+ausloeser+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlterminNichtWahlAusloeser(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlterminNichtWahlNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM StatistikLauf o WHERE o.wahltermin=?1 AND o.wahl IS NULL<br>
      * SQL: <br>
      */
     public java.util.List<StatistikLauf> findByWahlterminNichtWahl( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahltermin wahltermin) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.wahl.entity.Wahltermin wahlterminCheckedAndAttached =  checkAndAttach(wahltermin, de.ivu.elect.business.wahl.entity.Wahltermin.class, "wahltermin"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("STATISTIK_LAUF.WahlterminNichtWahl")
                              .setParameter(1, wahlterminCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("StatistikLauf, findByWahlterminNichtWahl - NonUniqueResultException, Parameter: "
           + ", wahltermin:'"+wahltermin+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahlterminNichtWahl(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }



  @Override
  public boolean isEntityWithUKPresent(de.ivu.elect.business.statistik.entity.StatistikLaufUK uk) {
    try {
      return findByUK(uk) != null;
    } catch (javax.persistence.NoResultException nre) {
      return false;
    }
  }

  @Override
  public boolean isEntityWithUKHasPK(de.ivu.elect.business.statistik.entity.StatistikLaufUK uk,
        de.ivu.elect.business.statistik.entity.StatistikLaufPK
      pk

  ) {
    try {
      return findByUK(uk).getPk().equals(pk);
    } catch (NoResultException ignored) {
      // Do nothing - be happy.
    }
    return true;
  }

    public de.ivu.elect.business.statistik.entity.StatistikLauf findByUK(de.ivu.elect.business.statistik.entity.StatistikLaufUK uk){
        throw new UnsupportedOperationException("Kein UK definiert");
    }


}